/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>

 Description: 
 */


#ifndef PARAMETERS_INCLUDED
#define PARAMETERS_INCLUDED

#include <algorithm>

using namespace std;

/************************************************************************************************************/

template<class T>
T max(T x, T y, T z) {
	return (max(x,y) >= z ? max(x,y) : z);
}

/*
template<class T>
T min(T x, T y) {
	return (x <= y ? x : y);
}
*/
template<class T>
T abs(T x) {
	return (x >= 0 ? x : -x);
}

struct ForkRecord
{
	unsigned int bifurcatePosMi;	//position in text where forks begin to bifurcate
	unsigned int bifurcatePosMj;	//position in pattern where forks begin to bifurcate
	unsigned int reuseForkNum;		//the number of the fork which this fork can use for reusing
	unsigned int reuseDepth;		//depth of the fork that can be reused
	unsigned int reuseMaxRow;		//the max row number that is eligible to be reused
};

struct Score
{
	int M1;
	int M2;
	int M3;
	int M;

};


struct pair_hashh
{
        size_t operator()(const pair<unsigned int,unsigned int> &p) const
        {
                return p.second<<16^p.first;
        }
};

struct compare_pair
{
	bool operator()(const  pair<unsigned int,unsigned int> &p1, const  pair<unsigned int,unsigned int> &p2) const
	{
		return (p1.first==p2.first && p1.second==p2.second);
	}
};


/************************************************************************************************************************/

#define ALPHABETSIZE 4

const char AlphabetSet[]={'A','G','C','T'};
//const char AlphabetSet[]={'A','R','N','D','C','Q','E','G','H','I','L','K','M','F','P','S','T','W','Y','V'};

class Parameters
{
public:
	static int matchScore;	//match score
	static int mismatchScore;	//mismatch score
	static int gapOpenScore;	//gap penalty
	static int gapExtendScore;		//gap score
	static double expectationValue;	//E-Value
	static unsigned thresholdH;	//score threshold
	static unsigned qLen;	//gram length
	static unsigned Lmax;

	static unsigned int GetCharNum(char c)
	{
		for (unsigned int i=0;i<ALPHABETSIZE;i++)
		{
			if (AlphabetSet[i]==c)
			{
				return i;
			}
		}

		return 0;
	}
};



#endif
