#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <fstream>
#include <sstream>
#include <cstring>
#include "ds_ssort.h"
#include <cctype>
#include <sys/time.h>

using namespace std;
#define BUFFERSIZE (1050*1024*1024)
//#define SMALLBUFFERSIZE 20000
char buffer[BUFFERSIZE];
int length;

void reverse_text(const int length)
{
	for(int i=0;i<length/2;++i)
		swap(buffer[i],buffer[length-1-i]);
}

void eliminate_char()
{
	char *sptr,*dptr;
	sptr=dptr=buffer;
	char *end=buffer+length;

	int count=0;
	while(sptr!=end)
	{
		if(isspace(*sptr))
			++sptr;
		else
		{
			*dptr++=*sptr++;
			++count;
		}
	}
	*dptr='\0';

	length=count;
}


void PrintShortDesc() {
	
	printf("\n");
	printf("BWT build, Copyright (C) 2011, Northeastern Universtiy.\n");
	printf("\n");

}

void PrintHelp() {

	printf("This program is free software; you can redistribute it and/or\n");
	printf("modify it under the terms of the GNU General Public License\n");
	printf("as published by the Free Software Foundation; either version 2\n");
	printf("of the License, or (at your option) any later version.\n");
	printf("\n");

	printf("This program is distributed in the hope that it will be useful,\n");
	printf("but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
	printf("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
	printf("GNU General Public License for more details.\n");
	printf("\n");

	printf("You should have received a copy of the GNU General Public License\n");
	printf("along with this program; if not, write to the Free Software\n");
	printf("Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.\n");
	printf("\n");

	printf("Syntax: bwt_build <text file> <output index file>\n");
}

int main(int argc, char* argv[])
{
unsigned totalTime = 0;
struct timeval tv1, tv2;
struct timezone tz;

	PrintShortDesc();

	string sa_FName;
	int *lf;
		
	if(argc > 2){
		freopen(argv[1], "r", stdin);
		sa_FName=string(argv[2])+".sa";
		freopen(argv[2], "w", stdout);
	}
	else
	{
		PrintHelp();
		return 0;
	}


	length =fread(buffer,1,BUFFERSIZE, stdin);
	if(length==0)
	{
		cerr<<"Something wrong when reading the text!"<<endl;
		exit(1);
	}

gettimeofday(&tv1, &tz);

	--length;//去掉末尾'\0'

	cerr<<"Reversing text...";	

	reverse_text(length);

	cerr<<"done"<<endl;
	
	eliminate_char();
	//printf("%s\n",buffer);

	//vector<int> sa;
	int overshoot = init_ds_ssort(500, 2000);
				
	unsigned char * texts = (unsigned char *)malloc(sizeof(unsigned char)*(length+overshoot));
	memcpy(texts, (unsigned char *)buffer, (length)*sizeof(unsigned char));
	lf = (int *)malloc(length * sizeof(int));
  	if (lf == NULL) {
  		cerr<<"failed to builded the suffix array"<<endl;
  		exit(0);PrintShortDesc();
  	}

	cerr<<"Sorting...";
       
 	 /* compute Suffix Array with library */  
  	ds_ssort(texts, lf, length);
 
	cerr<<"done"<<endl;
 	
	/*sa.push_back(length);
	for(int i = 0; i<length; i++)
	{
		sa.push_back(lf[i]);
	}
	*/

	cerr<<"Saving index...";

	printf("%c",buffer[length-1]);
	for(int i=1;i<=length;++i)
	{
		if(!lf[i-1])
			printf("\1");
		else
			printf("%c",buffer[lf[i-1]-1]);
	}
	/*
	for(int i =0; i<= length; i++)
	{
		if(!sa[i])
			printf("\1");
		else
			printf("%c",buffer[sa[i]-1]);
	}*/
	
	FILE *outSA;
	outSA = fopen(sa_FName.c_str(), "w");

	fprintf(outSA,"%d ",length);
	for(int i=1;i<=length;++i)
		fprintf(outSA,"%d ",lf[i-1]);
	/*
	for(int i = 0; i<= length; i++)
	{
		fprintf(outSA,"%d ", sa[i]);
	}
	*/
	cerr<<"done"<<endl;

gettimeofday(&tv2, &tz);
totalTime = (tv2.tv_sec - tv1.tv_sec);

cerr<<"Building bwt index time elapsed:	"<<totalTime<<"s"<<endl;

	return 0;
}
