/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>

 Description: 
 */

#include "pattern.h"

Pattern::Pattern(string &_pattern)
{
	pattern=_pattern;
	//CreateInvertedLists();
}

Pattern::~Pattern()
{
	for ( InvertedList::iterator iter = invertedList.begin();iter != invertedList.end(); ++iter )
		delete iter->second;  // free the array space
}

void Pattern::CreateInvertedLists()
{
	for (unsigned i = 0; i < pattern.length() - max(Parameters::thresholdH/Parameters::mismatchScore,Parameters::qLen) + 1; i++)
	{
		string gram = pattern.substr(i, Parameters::qLen);

		if (invertedList.find(gram) == invertedList.end())
		{
			gramsInPattern.push_back(gram);//remember the new gram

			vector<unsigned> *vectorGram = new vector<unsigned>();
			vectorGram->push_back(i);	//add the new gram to inverted lists
			invertedList[gram] = vectorGram;
		}
		else
		{
			vector<unsigned> *vectorGram = invertedList[gram];
			vectorGram->push_back(i);
		}
	}
}

vector<unsigned>* Pattern::GetGramList(string gram)
{

	if (invertedList.find(gram) == invertedList.end())
	{
		return NULL;
	}
	else
	{
		return invertedList[gram];
	}
}

string Pattern::GetNextGram()
{
	static unsigned int pointNum=0;
	string gram;

	if(pointNum<gramsInPattern.size())
	{
		gram=gramsInPattern.at(pointNum);
		pointNum++;
	}
	else
		gram="";

	return gram;

}

string Pattern::GetGram(unsigned int startPos)
{
    return pattern.substr(startPos, Parameters::qLen);
}

bool Pattern::IsCharExist(unsigned int mj)
{
	if(mj<pattern.length())
		return true;
	else
		return false;
}


char Pattern::GetChar(unsigned int mj)
{
	return pattern.at(mj);
}

void Pattern::SetPattern(string &_pattern)
{
	pattern=_pattern;
	gramsInPattern.clear();
	invertedList.clear();

	CreateInvertedLists();
}

unsigned Pattern::GetLength()
{
	return pattern.length();
}



